## ike 2.2.1+dfsg

=== CMakeLists.txt ===
#
# Shrew Soft VPN / IKE Tools
# Cross Platform Make File
#
# author : Matthew Grooms
#        : mgrooms@shrew.net
#        : Copyright 2012, Shrew Soft Inc
#

project( IKE )

cmake_minimum_required( VERSION 2.4 )

if( COMMAND cmake_policy )

	cmake_policy( SET CMP0003 NEW )

endif( COMMAND cmake_policy )

#
# Unix Target Constants
#

add_definitions( -DUNIX )

include( CheckCSourceCompiles )
include( CheckLibraryExists )

set(
	RELVER "2.2.1" )

subdirs(
	source/iked
	source/ikec
	source/libike
	source/libip
	source/libidb
	source/libith
	source/liblog
	source/libpfk )

set(
	SEARCH_INC
	/usr/local/include
	/usr/include )

set(
	SEARCH_LIB
	/usr/local/lib
	/usr/lib )

set(
	SEARCH_BIN
	/usr/local/bin
	/usr/pkg/bin
	/usr/bin )

set(
	SEARCH_SYS
	/usr/local
	/usr/share
	/usr )

#
# Apple OSX Target Constants
#

if( APPLE )

	set(
		CMAKE_OSX_ARCHITECTURES "x86_64" )

	set(
		CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-deprecated-declarations" )

	set(
		CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-deprecated-declarations" )

endif( APPLE )

#
# Path Option Checks
#

if( NOT EXISTS ${CMAKE_INSTALL_PREFIX} )

	set(
		CMAKE_INSTALL_PREFIX "/usr" )

endif( NOT EXISTS ${CMAKE_INSTALL_PREFIX} )

message(
	STATUS 
	"Using install prefix ${CMAKE_INSTALL_PREFIX} ..." )

# etc install path

if( ETCDIR )

	set(
		PATH_ETC ${ETCDIR} )

else( ETCDIR )

	if( EXISTS ${CMAKE_INSTALL_PREFIX}/etc )

		set(
			PATH_ETC "${CMAKE_INSTALL_PREFIX}/etc" )

	else( EXISTS ${CMAKE_INSTALL_PREFIX}/etc )
		
		set(
			PATH_ETC "/etc" )

	endif( EXISTS ${CMAKE_INSTALL_PREFIX}/etc )

endif( ETCDIR )

message(
	STATUS
	"Using etc install path ${PATH_ETC} ..." )

# bin install path

if( BINDIR )

	set(
		PATH_BIN ${BINDIR} )

else( BINDIR )

	if( EXISTS ${CMAKE_INSTALL_PREFIX}/bin )

		set(
			PATH_BIN "${CMAKE_INSTALL_PREFIX}/bin" )

	else( EXISTS ${CMAKE_INSTALL_PREFIX}/bin )

		set(
			PATH_LIB "/usr/bin" )

	endif( EXISTS ${CMAKE_INSTALL_PREFIX}/bin )

endif( BINDIR )

message(
	STATUS
	"Using bin install path ${PATH_BIN} ..." )

# sbin install path

if( SBINDIR )

	set(
		PATH_SBIN ${SBINDIR} )

else( SBINDIR )

	if( EXISTS ${CMAKE_INSTALL_PREFIX}/sbin )

		set(
			PATH_SBIN "${CMAKE_INSTALL_PREFIX}/sbin" )

	else( EXISTS ${CMAKE_INSTALL_PREFIX}/sbin )

		set(
			PATH_SBIN "/usr/sbin" )

	endif( EXISTS ${CMAKE_INSTALL_PREFIX}/sbin )

endif( SBINDIR )

message(
	STATUS
	"Using sbin install path ${PATH_SBIN} ..." )

# lib install path

if( LIBDIR )

	set(
		PATH_LIB ${LIBDIR} )

else( LIBDIR )

	if( EXISTS ${CMAKE_INSTALL_PREFIX}/lib )

		set(
			PATH_LIB "${CMAKE_INSTALL_PREFIX}/lib" )

	else( EXISTS ${CMAKE_INSTALL_PREFIX}/lib )

		set(
			PATH_LIB "/usr/lib" )

	endif( EXISTS ${CMAKE_INSTALL_PREFIX}/lib )

endif( LIBDIR )

message(
	STATUS
	"Using lib install path ${PATH_LIB} ..." )

# man install path

if( MANDIR )

	set(
		PATH_MAN ${MANDIR} )

else( MANDIR )

	find_path(
		PATH_MAN
		NAMES "man"
		PATHS ${SEARCH_SYS}
		NO_DEFAULT_PATH )

	if( PATH_MAN )

		set(
			PATH_MAN "${PATH_MAN}/man" )

	else( PATH_MAN )

		set(
			PATH_MAN "${CMAKE_INSTALL_PREFIX}/man" )

	endif( PATH_MAN )

endif( MANDIR )

message(
	STATUS
	"Using man install path ${PATH_MAN} ..." )

if( KRNINC )

	set(
		INC_KERNEL_DIR ${KRNINC} )

	message(
		STATUS
		"Using kernel include path ${INC_KERNEL_DIR} ..." )

endif( KRNINC )

#
# PreRequisite Checks
#

check_library_exists(
	"crypt"
	"crypt"
	""
	FUNC_LIB_CRYPT )

find_path(
	PATH_INC_CRYPTO
	NAMES "openssl/evp.h"
	PATHS ${SEARCH_INC} )

if( NOT PATH_INC_CRYPTO )

	message(
		FATAL_ERROR
		"Unable to locate openssl crypto include files" )

endif( NOT PATH_INC_CRYPTO )

find_library(
	PATH_LIB_CRYPTO
	NAMES "crypto"
	PATHS ${SEARCH_LIB} )

if( NOT PATH_LIB_CRYPTO )

	message(
		FATAL_ERROR
		"Unable to locate openssl crypto library file" )

endif( NOT PATH_LIB_CRYPTO )

find_path(
	PATH_INC_EDIT
	NAMES "histedit.h"
	PATHS ${SEARCH_INC} )

if( NOT PATH_INC_EDIT )

	message(
		FATAL_ERROR
		"Unable to locate libedit include files" )

endif( NOT PATH_INC_EDIT )

find_library(
	PATH_LIB_EDIT
	NAMES "edit"
	PATHS ${SEARCH_LIB} )

if( NOT PATH_LIB_EDIT )

	message(
		FATAL_ERROR
		"Unable to locate libedit library file" )

endif( NOT PATH_LIB_EDIT )

find_package(Threads)

message(
	STATUS
	"Using library ${CMAKE_THREAD_LIBS_INIT}" )

if( NOT CMAKE_USE_PTHREADS_INIT )

	message(
		FATAL_ERROR
		"Unable to locate required package : pthreads" )

endif( NOT CMAKE_USE_PTHREADS_INIT )

if( NOT APPLE )

	check_library_exists(
		${CMAKE_THREAD_LIBS_INIT}
		"pthread_mutex_timedlock"
		""
		FUNC_LIB_TIMEDLOCK )

endif( NOT APPLE )

if( FUNC_LIB_TIMEDLOCK )

	add_definitions( -DOPT_TIMEDLOCK )

endif( FUNC_LIB_TIMEDLOCK )

find_program(
	PATH_BIN_FLEX
	NAMES "flex"
	PATHS ${SEARCH_BIN} )

if( NOT PATH_BIN_FLEX )

	message(
		FATAL_ERROR
		"Unable to locate required binary : flex" )

endif( NOT PATH_BIN_FLEX )
		
message(
	STATUS 
	"Using binary ${PATH_BIN_FLEX} ..." )

find_program(
	PATH_BIN_BISON
	NAMES "bison"
	PATHS ${SEARCH_BIN} )

if( NOT PATH_BIN_BISON )

	message(
		FATAL_ERROR
		"Unable to locate required binary : bison" )

endif( NOT PATH_BIN_BISON )
		
message(
	STATUS 
	"Using binary ${PATH_BIN_BISON} ..." )

find_path(
	PATH_INC_NETIPSEC
	NAMES "ipsec.h"
	PATHS "/usr/include/netipsec" )

if( PATH_INC_NETIPSEC )

	add_definitions( -DOPT_NETIPSEC )

endif( PATH_INC_NETIPSEC )

find_library(
	PATH_LIB_RT
	NAMES "rt"
	PATHS ${SEARCH_LIB} )

find_path(
	PATH_INC_PFKEYV2
	NAMES "net/pfkeyv2.h" "linux/pfkeyv2.h"
	PATHS ${SEARCH_INC} ${INC_KERNEL_DIR} )

if( NOT PATH_INC_PFKEYV2 )

	message(
		FATAL_ERROR
		"Unable to locate system pfkeyv2 include file" )

endif( NOT PATH_INC_PFKEYV2 )

#
# Build Option Checks
#

OPTION( DEBUG   "include Debug Symbol support" )
OPTION( NATT    "include NAT Traversal support" )
OPTION( LDAP    "include LDAP Authentication support" )
OPTION( QTGUI   "include Client QT GUI support" )
OPTION( TESTS   "include library test programs" )
OPTION( ETCDIR  "custom etc install path" )
OPTION( BINDIR  "custom bin install path" )
OPTION( SBINDIR "custom sbin install path" )
OPTION( LIBDIR  "custom library install path" )
OPTION( MANDIR  "custom man page install path" )

# Debug Symbols Option

if( DEBUG )

	add_definitions( -g )

endif( DEBUG )

# NAT Traversion option

if( NATT )

	if( NOT APPLE )

		check_c_source_compiles(
			"
			#ifdef __linux__
			# include <inttypes.h>
			# include <linux/pfkeyv2.h>
			#else
			# include <sys/types.h>
			# include <net/pfkeyv2.h>
			#endif

			int main()
			{
				struct sadb_x_nat_t_type test;
				return 0;
			}
			"
			NATT_FOUND )

	else( NOT APPLE )

		set(
			NATT_FOUND TRUE )

	endif( NOT APPLE )

	if( NOT NATT_FOUND )

		message(
			FATAL_ERROR
			"Unable to locate required NAT-T pfkey structures" )

	endif( NOT NATT_FOUND )

	# success

	message(
		STATUS 
		"Enabled NAT Traversal support ..." )

	add_definitions( -DOPT_NATT )

endif( NATT )

# LDAP support option

if( LDAP )

	# ldap include

	find_path(
		PATH_INC_LDAP
		NAMES "ldap.h"
		PATHS ${SEARCH_INC} )

	if( NOT PATH_INC_LDAP )

		message(
			FATAL_ERROR
			"Unable to locate LDAP include file" )

	endif( NOT PATH_INC_LDAP )

	# ldap libraries

	find_library(
		PATH_LIB_LDAP
		NAMES "ldap"
		PATHS ${SEARCH_LIB} )

	find_library(
		PATH_LIB_LBER
		NAMES "lber"
		PATHS ${SEARCH_LIB} )

	if( NOT PATH_LIB_LDAP OR NOT PATH_LIB_LBER )

		message(
			FATAL_ERROR
			"Unable to locate LDAP library file" )

	endif( NOT PATH_LIB_LDAP OR NOT PATH_LIB_LBER )

	# success

	message( 
		STATUS
		"Enabled LDAP Authentication support ..." )

	add_definitions( -DOPT_LDAP )

endif( LDAP )

# Client GUI option

if( QTGUI )

	add_definitions( -DQT_THREAD_SUPPORT )

	find_package(
		Qt4
		COMPONENTS QtCore QtGui REQUIRED )

	if( NOT QT_QTGUI_FOUND )

		message(
			FATAL_ERROR
			"Unable to locate required package : QT" )

	endif( NOT QT_QTGUI_FOUND )
		
	# success

	message(
		STATUS 
		"Enabled Client QT GUI support ..." )

	if( APPLE )

		add_subdirectory( source/libqt )

	endif( APPLE )

	add_subdirectory( source/qikea )
	add_subdirectory( source/qikec )

endif( QTGUI )

# Library Test Programs

if( TESTS )

	message(
		STATUS 
		"Building library test programs ..." )

	add_subdirectory( source/test_ith )

endif( TESTS )

=== source/ikec/CMakeLists.txt ===
#
# Shrew Soft VPN / Client Connect Application
# Cross Platform Make File
#
# author : Matthew Grooms
#        : mgrooms@shrew.net
#        : Copyright 2007, Shrew Soft Inc
#

include_directories(
	${IKE_SOURCE_DIR}/source/
	${IKE_SOURCE_DIR}/source/ikea
	${IKE_SOURCE_DIR}/source/iked
	${IKE_SOURCE_DIR}/source/libike
	${IKE_SOURCE_DIR}/source/libidb
	${IKE_SOURCE_DIR}/source/libith
	${IKE_SOURCE_DIR}/source/liblog
	${IKE_SOURCE_DIR}/source/libip
	${QT_INCLUDES} )

link_directories(
	${IKE_SOURCE_DIR}/source/libip )

add_executable(
	ikec
	main.cpp
	ikec.cpp )

target_link_libraries(
	ikec
	ss_ike
	ss_idb
	ss_ith
	ss_log
	crypto
	pthread
	edit )

# install support

install(
	TARGETS ikec
	RUNTIME	DESTINATION ${PATH_BIN} )

install(
	FILES ikec.1
	DESTINATION ${PATH_MAN}/man1 )

=== source/iked/CMakeLists.txt ===
#
# Shrew Soft VPN / IKE Daemon
# Cross Platform Make File
#
# author : Matthew Grooms
#        : mgrooms@shrew.net
#        : Copyright 2007, Shrew Soft Inc
#

add_definitions( -D PATH_CONF=\\"${PATH_ETC}\\" )

include_directories(
	${IKE_SOURCE_DIR}/source
	${IKE_SOURCE_DIR}/source/iked
	${IKE_SOURCE_DIR}/source/libike
	${IKE_SOURCE_DIR}/source/libidb
	${IKE_SOURCE_DIR}/source/libith
	${IKE_SOURCE_DIR}/source/libip
	${IKE_SOURCE_DIR}/source/liblog
	${IKE_SOURCE_DIR}/source/libpfk
	${INC_KERNEL_DIR} )

link_directories(
	${IKE_SOURCE_DIR}/source/libike
	${IKE_SOURCE_DIR}/source/libidb
	${IKE_SOURCE_DIR}/source/libith
	${IKE_SOURCE_DIR}/source/libip
	${IKE_SOURCE_DIR}/source/liblog
	${IKE_SOURCE_DIR}/source/libpfk )

add_executable(
	iked
	crypto.cpp
	conf.parse.cpp
	conf.token.cpp
	dhcp.cpp
	ike.cpp
	ike.exch.config.cpp
	ike.exch.inform.cpp
	ike.exch.phase1.cpp
	ike.exch.phase2.cpp
	ike.idb.config.cpp
	ike.idb.inform.cpp
	ike.idb.lists.cpp
	ike.idb.phase1.cpp
	ike.idb.phase2.cpp
	ike.idb.peer.cpp
	ike.idb.policy.cpp
	ike.idb.tunnel.cpp
	ike.idb.exch.cpp
	ike.io.admin.cpp
	ike.io.network.cpp
	ike.io.pfkey.cpp
	ike.keyfile.cpp
	ike.names.cpp
	ike.nethlp.cpp
	ike.packet.cpp
	ike.payload.cpp
	ike.peerid.cpp
	ike.policy.cpp
	ike.proposal.cpp
	ike.socket.cpp
	ike.xauth.cpp
	ike.xconf.cpp
	iked.cpp
	main.cpp )

target_link_libraries(
	iked
	ss_ike
	ss_idb
	ss_ith
	ss_ip
	ss_log
	ss_pfk
	crypto
	pthread )

if( FUNC_LIB_CRYPT )

target_link_libraries(
	iked
	crypt )

endif( FUNC_LIB_CRYPT )

# LDAP support option

if( LDAP )

	include_directories(
		${PATH_INC_LDAP} )

	target_link_libraries(
		iked
		${PATH_LIB_LDAP}
		${PATH_LIB_LBER} )

endif( LDAP )

set_source_files_properties(
	conf.parse.cpp GENERATED,
	conf.token.cpp GENERATED )

# Custom target for parser

add_custom_target( ConfParser echo "Creating Conf Parser" )

# Custom command for flex

add_custom_command(
	SOURCE conf.token.ll
	COMMAND ${PATH_BIN_FLEX}
	ARGS -d -oconf.token.cpp conf.token.ll
	TARGET ConfParser
	OUTPUTS conf.token.cpp )

# Custom command for bison

add_custom_command(
	SOURCE conf.parse.yy
	COMMAND ${PATH_BIN_BISON}
	ARGS -oconf.parse.cpp conf.parse.yy
	TARGET ConfParser
	OUTPUTS conf.parse.cpp conf.parse.hpp location.hh position.hh stack.hh )

# install support

install(
	TARGETS iked
	RUNTIME DESTINATION ${PATH_SBIN} )

install(
	FILES iked.8
	DESTINATION ${PATH_MAN}/man8 )

install(
	FILES iked.conf.5
	DESTINATION ${PATH_MAN}/man5 )

install(
	FILES iked.conf.sample
	DESTINATION ${PATH_ETC} )

=== source/libidb/CMakeLists.txt ===
#
# Shrew Soft VPN / Internal Object Database
# Cross Platform Make File
#
# author : Matthew Grooms
#        : mgrooms@shrew.net
#        : Copyright 2007, Shrew Soft Inc
#

include_directories(
	${IKE_SOURCE_DIR}/source
	${IKE_SOURCE_DIR}/source/libip
	${IKE_SOURCE_DIR}/source/liblog
	${IKE_SOURCE_DIR}/source/libith )

add_library(
	ss_idb SHARED
	libidb.cpp
	base64.cpp )

target_link_libraries(
	ss_idb
	ss_ith
	ss_log )

set_target_properties(
	ss_idb PROPERTIES
	VERSION ${RELVER}
	SOVERSION ${RELVER} )

if( APPLE )

	set(
		MACOSX_BUNDLE_BUNDLE_NAME
		"ShrewSoftIdb" )

	set_property(
		TARGET ss_idb
		PROPERTY FRAMEWORK ON )

	set_property(
		TARGET ss_idb
		PROPERTY OUTPUT_NAME ${MACOSX_BUNDLE_BUNDLE_NAME} )

endif( APPLE )

install(
	TARGETS ss_idb
	LIBRARY DESTINATION ${PATH_LIB}
	FRAMEWORK DESTINATION "/Library/Frameworks" )

=== source/libike/CMakeLists.txt ===

#
# Shrew Soft VPN / IKE Daemon Interface Library
# Cross Platform Make File
#
# author : Matthew Grooms
#        : mgrooms@shrew.net
#        : Copyright 2007, Shrew Soft Inc
#

include_directories(
        ${IKE_SOURCE_DIR}/source
        ${IKE_SOURCE_DIR}/source/iked
        ${IKE_SOURCE_DIR}/source/libike
        ${IKE_SOURCE_DIR}/source/libidb
        ${IKE_SOURCE_DIR}/source/libith
        ${IKE_SOURCE_DIR}/source/liblog
        ${IKE_SOURCE_DIR}/source/libip )

add_library(
	ss_ike SHARED
	client.cpp
	config.cpp
	manager.cpp
	manager.file.cpp
	libike.cpp )

target_link_libraries(
	ss_ike
	ss_idb
	ss_ith
	crypto )

set_target_properties(
	ss_ike PROPERTIES
	VERSION ${RELVER}
	SOVERSION ${RELVER} )

if( APPLE )

	set(
		MACOSX_BUNDLE_BUNDLE_NAME
		"ShrewSoftIke" )

	set_property(
		TARGET ss_ike
		PROPERTY FRAMEWORK ON )

	set_property(
		TARGET ss_ike
		PROPERTY OUTPUT_NAME ${MACOSX_BUNDLE_BUNDLE_NAME} )

endif( APPLE )

install(
	TARGETS ss_ike
	LIBRARY DESTINATION ${PATH_LIB}
	FRAMEWORK DESTINATION "/Library/Frameworks" )

=== source/libip/CMakeLists.txt ===
#
# Shrew Soft VPN / IP Utility Library
# Cross Platform Make File
#
# author : Matthew Grooms
#        : mgrooms@shrew.net
#        : Copyright 2007, Shrew Soft Inc
#

include_directories(
	${IKE_SOURCE_DIR}/source
	${IKE_SOURCE_DIR}/source/libidb
	${IKE_SOURCE_DIR}/source/liblog
	${IKE_SOURCE_DIR}/source/libith )

add_library(
	ss_ip SHARED
	libip.frag.cpp
	libip.packet.cpp
	libip.packet.dns.cpp
	libip.packet.ip.cpp
	libip.packet.udp.cpp
	libip.pcap.cpp
	libip.queue.cpp
	libip.route.cpp )

target_link_libraries(
	ss_ip
	ss_idb )

set_target_properties(
	ss_ip
	PROPERTIES
	VERSION ${RELVER}
	SOVERSION ${RELVER} )

if( APPLE )

	set(
		MACOSX_BUNDLE_BUNDLE_NAME
		"ShrewSoftIp" )

	set_property(
		TARGET ss_ip
		PROPERTY FRAMEWORK ON )

	set_property(
		TARGET ss_ip
		PROPERTY OUTPUT_NAME ${MACOSX_BUNDLE_BUNDLE_NAME} )

endif( APPLE )

install(
	TARGETS ss_ip
	LIBRARY DESTINATION ${PATH_LIB}
	FRAMEWORK DESTINATION "/Library/Frameworks" )

=== source/libith/CMakeLists.txt ===
#
# Shrew Soft VPN / Timer and Thread Library
# Cross Platform Make File
#
# author : Matthew Grooms
#        : mgrooms@shrew.net
#        : Copyright 2007, Shrew Soft Inc
#

include_directories(
	${IKE_SOURCE_DIR}/source )

add_library(
	ss_ith SHARED
	libith.cpp )

# Linux realtime library

if( PATH_LIB_RT )

	target_link_libraries(
		ss_ith
		rt )

endif( PATH_LIB_RT )

set_target_properties(
	ss_ith PROPERTIES
	VERSION ${RELVER}
	SOVERSION ${RELVER} )

if( APPLE )

	set(
		MACOSX_BUNDLE_BUNDLE_NAME
		"ShrewSoftIth" )

	set_property(
		TARGET ss_ith
		PROPERTY FRAMEWORK ON )

	set_property(
		TARGET ss_ith
		PROPERTY OUTPUT_NAME ${MACOSX_BUNDLE_BUNDLE_NAME} )

endif( APPLE )

install(
	TARGETS ss_ith
	LIBRARY DESTINATION ${PATH_LIB}
	FRAMEWORK DESTINATION "/Library/Frameworks" )

=== source/liblog/CMakeLists.txt ===
#
# Shrew Soft VPN / Log Facility Library
# Cross Platform Make File
#
# author : Matthew Grooms
#        : mgrooms@shrew.net
#        : Copyright 2007, Shrew Soft Inc
#

include_directories(
        ${IKE_SOURCE_DIR}/source
        ${IKE_SOURCE_DIR}/source/libith )

add_library(
	ss_log SHARED
	liblog.cpp )

target_link_libraries(
	ss_log
	ss_ith )

set_target_properties(
	ss_log PROPERTIES
	VERSION ${RELVER}
	SOVERSION ${RELVER} )

if( APPLE )

	set(
		MACOSX_BUNDLE_BUNDLE_NAME
		"ShrewSoftLog" )

	set_property(
		TARGET ss_log
		PROPERTY FRAMEWORK ON )

	set_property(
		TARGET ss_log
		PROPERTY OUTPUT_NAME ${MACOSX_BUNDLE_BUNDLE_NAME} )

endif( APPLE )

install(
	TARGETS ss_log
	LIBRARY DESTINATION ${PATH_LIB}
	FRAMEWORK DESTINATION "/Library/Frameworks" )

=== source/libpfk/CMakeLists.txt ===
#
# Shrew Soft VPN / PF KEY Helper Library
# Cross Platform Make File
#
# author : Matthew Grooms
#        : mgrooms@shrew.net
#        : Copyright 2007, Shrew Soft Inc
#

include_directories(
        ${IKE_SOURCE_DIR}/source
        ${IKE_SOURCE_DIR}/source/libidb
        ${IKE_SOURCE_DIR}/source/libith
        ${IKE_SOURCE_DIR}/source/liblog
	${INC_KERNEL_DIR} )

add_library(
	ss_pfk SHARED
	libpfk.cpp )

target_link_libraries(
	ss_pfk
	ss_idb )

set_target_properties(
	ss_pfk PROPERTIES
	VERSION ${RELVER}
	SOVERSION ${RELVER} )

if( APPLE )

	set(
		MACOSX_BUNDLE_BUNDLE_NAME
		"ShrewSoftPfkey" )

	set_property(
		TARGET ss_pfk
		PROPERTY FRAMEWORK ON )

	set_property(
		TARGET ss_pfk
		PROPERTY OUTPUT_NAME ${MACOSX_BUNDLE_BUNDLE_NAME} )

endif( APPLE )

install(
	TARGETS ss_pfk
	LIBRARY DESTINATION ${PATH_LIB}
	FRAMEWORK DESTINATION "/Library/Frameworks" )

=== source/libqt/CMakeLists.txt ===
#
# Shrew Soft VPN / QT Private Libs
# Cross Platform Make File
#
# author : Matthew Grooms
#        : mgrooms@shrew.net
#        : Copyright 2007, Shrew Soft Inc
#

if( APPLE )

	# QtCore Private Library Framework

	install(
		DIRECTORY "${QT_LIBRARY_DIR}/QtCore.framework/Contents"
		DESTINATION "/Library/Frameworks/ShrewSoftQtCore.framework"
		COMPONENT Runtime )

	install(
		FILES "${QT_LIBRARY_DIR}/QtCore.framework/Versions/4/QtCore"
		DESTINATION "/Library/Frameworks/ShrewSoftQtCore.framework/Versions/4"
		RENAME "ShrewSoftQtCore"
		COMPONENT Runtime )

	install(
		CODE "execute_process( COMMAND \"ln\" -s
			4
			/Library/Frameworks/ShrewSoftQtCore.framework/Versions/Current )" )

	install(
		CODE "execute_process( COMMAND \"ln\" -s
			Versions/4/Resources
			/Library/Frameworks/ShrewSoftQtCore.framework/Resources )" )

	install(
		CODE "execute_process( COMMAND \"install_name_tool\" -id
			ShrewSoftQtCore.framework/Versions/4/ShrewSoftQtCore
			/Library/Frameworks/ShrewSoftQtCore.framework/Versions/4/ShrewSoftQtCore )" )

	# QtGui Private Library Framework

	install(
		DIRECTORY "${QT_LIBRARY_DIR}/QtGui.framework/Contents"
		DESTINATION "${QT_LIBRARY_DIR}/ShrewSoftQtGui.framework"
		COMPONENT Runtime )

	install(
		FILES "${QT_LIBRARY_DIR}/QtGui.framework/Versions/4/QtGui"
		DESTINATION "/Library/Frameworks/ShrewSoftQtGui.framework/Versions/4"
		RENAME "ShrewSoftQtGui"
		COMPONENT Runtime )

	install(
		CODE "execute_process( COMMAND \"ln\" -s
			4
			/Library/Frameworks/ShrewSoftQtGui.framework/Versions/Current )" )

	install(
		CODE "execute_process( COMMAND \"ln\" -s
			Versions/4/Resources
			/Library/Frameworks/ShrewSoftQtGui.framework/Resources )" )

	install(
		DIRECTORY "${QT_LIBRARY_DIR}/QtGui.framework/Versions/4/Resources"
		DESTINATION "/Library/Frameworks/ShrewSoftQtGui.framework/Versions/4"
		COMPONENT Runtime )

	install(
		CODE "execute_process( COMMAND \"install_name_tool\" -id
			ShrewSoftQtGui.framework/Versions/4/ShrewSoftQtGui
			/Library/Frameworks/ShrewSoftQtGui.framework/Versions/4/ShrewSoftQtGui )" )

	install(
		CODE "execute_process( COMMAND \"install_name_tool\" -change
			${QT_LIBRARY_DIR}/QtCore.framework/Versions/4/QtCore
			ShrewSoftQtCore.framework/Versions/4/ShrewSoftQtCore
			/Library/Frameworks/ShrewSoftQtGui.framework/Versions/4/ShrewSoftQtGui )" )

endif( APPLE )

=== source/qikea/CMakeLists.txt ===
#
# Shrew Soft VPN / Access Manager Application
# Cross Platform Make File
#
# author : Matthew Grooms
#        : mgrooms@shrew.net
#        : Copyright 2007, Shrew Soft Inc
#

include_directories(
	${IKE_SOURCE_DIR}/source/
	${IKE_SOURCE_DIR}/source/ikec
	${IKE_SOURCE_DIR}/source/libike
	${IKE_SOURCE_DIR}/source/libidb
	${IKE_SOURCE_DIR}/source/libith
	${IKE_SOURCE_DIR}/source/liblog
	${QT_INCLUDES} )

link_directories(
	${IKE_SOURCE_DIR}/source/libip
	${QT_LIBRARY_DIR} )

include( ${QT_USE_FILE} )

qt4_wrap_ui(
	UIH_FILES
	about.ui
	conflict.ui
	root.ui
	site.ui
	topology.ui )

qt4_wrap_cpp(
	CXX_FILES
	qikea.h )

qt4_add_resources(
	QRC_FILES
	qikea.qrc )

add_executable(
	qikea
	main.cpp
	qikea.cpp
	root.cpp
	site.cpp
	topology.cpp
	${UIH_FILES}
	${CXX_FILES}
	${QRC_FILES} )

target_link_libraries(
	qikea
	ss_ike
	ss_idb
	ss_ith
	ss_log
	crypto
	pthread
	${QT_LIBRARIES} )

if( APPLE )

	set(
		MACOSX_BUNDLE_BUNDLE_NAME
		"Shrew Soft VPN Access Manager" )

	set(
		MACOSX_BUNDLE_GUI_IDENTIFIER
		"net.shrew.vpn.qikea" )

	set(
		MACOSX_BUNDLE_ICON_FILE
		"qikea.icns" )

	set(
		MACOSX_BUNDLE_LONG_VERSION_STRING
		${RELVER} )

	set(
		MACOSX_BUNDLE_SHORT_VERSION_STRING
		${RELVER} )

	set_property(
		TARGET qikea
		PROPERTY MACOSX_BUNDLE ON )

	set_property(
		TARGET qikea
		PROPERTY OUTPUT_NAME ${MACOSX_BUNDLE_BUNDLE_NAME} )

	add_custom_target(
		qikea-bundle-resources
		COMMAND mkdir -p
			${CMAKE_CURRENT_SOURCE_DIR}/${MACOSX_BUNDLE_BUNDLE_NAME}.app/Contents/Resources
		COMMAND cp
			${CMAKE_CURRENT_SOURCE_DIR}/png/${MACOSX_BUNDLE_ICON_FILE}
			${CMAKE_CURRENT_SOURCE_DIR}/${MACOSX_BUNDLE_BUNDLE_NAME}.app/Contents/Resources/${MACOSX_BUNDLE_ICON_FILE} )

	add_dependencies(
		qikea
		ProjectName qikea-bundle-resources )

endif( APPLE )

install(
	TARGETS qikea
	RUNTIME	DESTINATION bin
	BUNDLE DESTINATION "/Applications" )

install(
	FILES qikea.1
	DESTINATION ${PATH_MAN}/man1 )

if( APPLE )

#	set(
#		MACOSX_BUNDLE_DEST_DIR
#		"/Applications/${MACOSX_BUNDLE_BUNDLE_NAME}.app" )

#	set(
#		MACOSX_QTPLUGINS_DEST_DIR
#		"${MACOSX_BUNDLE_DEST_DIR}/Contents/MacOS/plugins" )

#	install(
#		DIRECTORY "${QT_PLUGINS_DIR}/imageformats"
#		DESTINATION "${MACOSX_QTPLUGINS_DEST_DIR}"
#		COMPONENT Runtime )

#	set(
#		MACOSX_QTCONF_DEST_DIR
#		"${MACOSX_BUNDLE_DEST_DIR}/Contents/Resources" )

#	install(
#		CODE "file( WRITE \"${MACOSX_QTCONF_DEST_DIR}/qt.conf\" \"\" )"
#		COMPONENT Runtime )

	install(
		CODE "execute_process( COMMAND \"install_name_tool\" -change
			${QT_LIBRARY_DIR}/QtCore.framework/Versions/4/QtCore
			ShrewSoftQtCore.framework/Versions/4/ShrewSoftQtCore
			\"/Applications/${MACOSX_BUNDLE_BUNDLE_NAME}.app/Contents/MacOS/${MACOSX_BUNDLE_BUNDLE_NAME}\" )" )

	install(
		CODE "execute_process( COMMAND \"install_name_tool\" -change
			${QT_LIBRARY_DIR}/QtGui.framework/Versions/4/QtGui
			ShrewSoftQtGui.framework/Versions/4/ShrewSoftQtGui
			\"/Applications/${MACOSX_BUNDLE_BUNDLE_NAME}.app/Contents/MacOS/${MACOSX_BUNDLE_BUNDLE_NAME}\" )" )

endif( APPLE )

=== source/qikec/CMakeLists.txt ===
#
# Shrew Soft VPN / Client Connect Application
# Cross Platform Make File
#
# author : Matthew Grooms
#        : mgrooms@shrew.net
#        : Copyright 2007, Shrew Soft Inc
#

include_directories(
	${IKE_SOURCE_DIR}/source/
	${IKE_SOURCE_DIR}/source/ikec
	${IKE_SOURCE_DIR}/source/iked
	${IKE_SOURCE_DIR}/source/libike
	${IKE_SOURCE_DIR}/source/libidb
	${IKE_SOURCE_DIR}/source/libith
	${IKE_SOURCE_DIR}/source/liblog
	${IKE_SOURCE_DIR}/source/libip
	${QT_INCLUDES} )

link_directories(
	${IKE_SOURCE_DIR}/source/libip
	${QT_LIBRARY_DIR} )

include( ${QT_USE_FILE} )

qt4_wrap_ui(
	UIH_FILES
	banner.ui
	filepass.ui
	root.ui )

qt4_wrap_cpp(
	CXX_FILES
	qikec.h )

qt4_add_resources(
	QRC_FILES
	qikec.qrc )

add_executable(
	qikec
	main.cpp
	qikec.cpp
	root.cpp
	${UIH_FILES}
	${CXX_FILES}
	${QRC_FILES} )

target_link_libraries(
	qikec
	ss_ike
	ss_idb
	ss_ith
	ss_log
	crypto
	pthread
	${QT_LIBRARIES} )

if( APPLE )

	set(
		MACOSX_BUNDLE_BUNDLE_NAME
		"Shrew Soft VPN Client Connect" )

	set(
		MACOSX_BUNDLE_GUI_IDENTIFIER
		"net.shrew.vpn.qikec" )

	set(
		MACOSX_BUNDLE_ICON_FILE
		"qikec.icns" )

	set(
		MACOSX_BUNDLE_LONG_VERSION_STRING
		${RELVER} )

	set(
		MACOSX_BUNDLE_SHORT_VERSION_STRING
		${RELVER} )

	set_property(
		TARGET qikec
		PROPERTY MACOSX_BUNDLE ON )

	set_property(
		TARGET qikec
		PROPERTY OUTPUT_NAME ${MACOSX_BUNDLE_BUNDLE_NAME} )

	add_custom_target(
		qikec-bundle-resources
		COMMAND mkdir -p
			${CMAKE_CURRENT_SOURCE_DIR}/${MACOSX_BUNDLE_BUNDLE_NAME}.app/Contents/Resources
		COMMAND cp
			${CMAKE_CURRENT_SOURCE_DIR}/png/${MACOSX_BUNDLE_ICON_FILE}
			${CMAKE_CURRENT_SOURCE_DIR}/${MACOSX_BUNDLE_BUNDLE_NAME}.app/Contents/Resources/${MACOSX_BUNDLE_ICON_FILE} )

	add_dependencies(
		qikec
		ProjectName qikec-bundle-resources )

endif( APPLE )

install(
	TARGETS qikec
	RUNTIME	DESTINATION bin
	BUNDLE DESTINATION "/Applications" )

install(
	FILES qikec.1
	DESTINATION ${PATH_MAN}/man1 )

if( APPLE )

#	set(
#		MACOSX_BUNDLE_DEST_DIR
#		"/Applications/${MACOSX_BUNDLE_BUNDLE_NAME}.app" )

#	set(
#		MACOSX_QTPLUGINS_DEST_DIR
#		"${MACOSX_BUNDLE_DEST_DIR}/Contents/MacOS/plugins" )

#	install(
#		DIRECTORY "${QT_PLUGINS_DIR}/imageformats"
#		DESTINATION "${MACOSX_QTPLUGINS_DEST_DIR}"
#		COMPONENT Runtime )

#	set(
#		MACOSX_QTCONF_DEST_DIR
#		"${MACOSX_BUNDLE_DEST_DIR}/Contents/Resources" )

#	install(
#		CODE "file( WRITE \"${MACOSX_QTCONF_DEST_DIR}/qt.conf\" \"\" )"
#		COMPONENT Runtime )

	install(
		CODE "execute_process( COMMAND \"install_name_tool\" -change
			${QT_LIBRARY_DIR}/QtCore.framework/Versions/4/QtCore
			ShrewSoftQtCore.framework/Versions/4/ShrewSoftQtCore
			\"/Applications/${MACOSX_BUNDLE_BUNDLE_NAME}.app/Contents/MacOS/${MACOSX_BUNDLE_BUNDLE_NAME}\" )" )

	install(
		CODE "execute_process( COMMAND \"install_name_tool\" -change
			${QT_LIBRARY_DIR}/QtGui.framework/Versions/4/QtGui
			ShrewSoftQtGui.framework/Versions/4/ShrewSoftQtGui
			\"/Applications/${MACOSX_BUNDLE_BUNDLE_NAME}.app/Contents/MacOS/${MACOSX_BUNDLE_BUNDLE_NAME}\" )" )

endif( APPLE )

=== debian/control ===
Source: ike
Section: net
Priority: extra
Maintainer: Christian Hofstaedtler <zeha@debian.org>
Build-Depends: debhelper (>= 9), flex, bison (>= 2.3), libqt4-dev, libssl-dev (>= 0.9), cmake (>= 2.4), dpkg-dev (>= 1.16.1.1), libedit-dev
Standards-Version: 3.9.6
Homepage: http://www.shrew.net/
Vcs-Git: git://anonscm.debian.org/collab-maint/ike.git
Vcs-Browser: http://anonscm.debian.org/cgit/collab-maint/ike.git/

Package: ike
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: ike-qtgui, ipsec-tools
Provides: ike-server
Conflicts: ike-server
Replaces: ike-qtgui (<= 2.2)
Breaks: ike-qtgui (<= 2.2)
Description: Shrew Soft VPN client - Daemon and libraries
 The Shrew Soft VPN client is a free IPsec VPN Client for FreeBSD, NetBSD,
 Linux and Windows operating systems. This product can be used to communicate
 with Open Source VPN servers (e.g. ipsec-tools) as well as some commercial
 VPN servers.
 .
 This package provides a IKEv1 (ipsec key exchange) daemon and libraries used
 to maintain a IPSec VPN connection. It provides similar functionality as
 racoon, OpenSwan, FreeSwan, StrongSwan, IsaKmpD but is more user-interactive.
 .
 Note: You should install the ike-qtgui package to have a graphical
 user interface to configure and use VPN connections.

Package: ike-qtgui
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: ike (>= ${binary:Version})
Description: Shrew Soft VPN client - Connection manager
 The Shrew Soft VPN Client is a free IPsec VPN Client for FreeBSD, NetBSD,
 Linux and Windows operating systems. This product can be used to communicate
 with Open Source VPN servers (e.g. ipsec-tools) as well as some commercial
 VPN servers.
 .
 This package provides the connection manager program, which allows one
 to create, manage and use VPN connections.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

DEB_HOST_GNU_TYPE := $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)


# Files to delete from the source archive to be in accordance with the Debian free software guidelines
DFSG_FILESTOCLEAN = ike/docs/*

VERSION:=$(shell dpkg-parsechangelog | grep '^Version' | sed 's/Version: //' | sed -e 's/+[^+]*$$//')
URL = http://www.shrew.net/download/ike/ike-$(VERSION)-release.tgz

get-orig-source:
	wget -O ike.tar.gz "$(URL)"
	tar zxvf ike.tar.gz
	$(RM) $(DFSG_FILESTOCLEAN)
	mkdir tmp
	mv ike tmp/ike-$(VERSION)+dfsg
	cd tmp && tar cvf ike_$(VERSION)+dfsg.orig.tar ike-$(VERSION)+dfsg
	cd tmp && gzip -9 ike_$(VERSION)+dfsg.orig.tar
	mv tmp/ike_$(VERSION)+dfsg.orig.tar.gz .
	$(RM) -R tmp
	$(RM) ike.tar.gz


%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure -- -DQTGUI=YES -DNATT=YES -DCMAKE_INSTALL_PREFIX:PATH=/usr -DETCDIR:PATH=/etc -DMANDIR:PATH=/usr/share/man -DLIBDIR=/usr/lib/$(DEB_HOST_GNU_TYPE)/ike -DCMAKE_INSTALL_RPATH:UNINITIALIZED=/usr/lib/$(DEB_HOST_GNU_TYPE)/ike -DDEBUG=YES


override_dh_auto_install:
	dh_auto_install
	mv debian/tmp/etc/iked.conf.sample debian/tmp/etc/iked.conf

override_dh_installchangelogs:
	dh_installchangelogs TODO.TXT

override_dh_installinit:
	dh_installinit -p ike --error-handler=ike_error

override_dh_makeshlibs:
	dh_makeshlibs -n

override_dh_shlibdeps:
	dh_shlibdeps -l/usr/lib/ike

=== debian/watch ===
# See uscan(1) for format

# Compulsory line, this is a version 3 file
version=3

opts=dversionmangle=s/\+dfsg$// \
 http://www.shrew.net/download/ike /download/ike/ike-(.*)-release.tgz
